# Základní informace

Projekt je realizován v domě autora na adrese: Novosuchdolská 581/5a, 16500 Praha - Suchdol.

Řídící program je označován dvěma písmeny **rh** dle RaZberry Home (nabízelo se také Raspberry Pi Home resp. Raspberry Home). **RaZberry** je použitý Z-Wave modul pro Raspberry Pi. **Z-Wave** je IoT technologie v této domácnosti využitá u chytrých zásuvek, termostatů a elektrokotle. Dále se používá **TCP/IP** pro komunikaci řídícího počítače se střídačem fotovoltaické elektrárny, pro komunikaci řídícího počítače s ostaními počítači a pro přístup autora na řídící i ostatní počítače.

Níže je stručný popis jednotlivých komponent. Detailnější popis je na následujících stránkách.

## fronius

Střídač fotovoltaické elektrárny. Přes TCP/IP pomocí JSON API poskytuje informace o aktuální výrobě elektrické energie, o stavu nabití akumulátoru a o prodeji resp. nákupu elekřiny z rozvodné sítě.

## hub

Raspberry Pi počítač `rpi04.navratil.lan` s IPv4 adresou 192.168.4.9 dostupný přes alias `hub`. Je osazen Z-Wave modulem a ovládá Z-Wave zařízení a poskytuje informace řídícímu počítači.

Dále je zde nainstalovaná InfluxDB, do které jsou průběžně ukládány aktuální hodnoty Z-Wave zařízení. Řídící aplikace se dotazuje na většinu údajů do InfluxDB, aby nezatěžovala Z-Wave síť.

Na počátku byl tento počítač řídícím a jediným nasazeným Raspberry Pi počítačem. V rámci dalšího inkrementálního vývoje a testování, přidání PostgreSQL RDBMS a použití LCD displeje byly využity další počítače Raspberry Pi autora. V zadání diplomové práce není omezení na počet použitých Raspberry Pi počítačů. Kromě LCD displeje, který využivá stejně jako Z-Wave modul jedno GPIO rozhranní Raspberry Pi počítače, je možné přejít na pouze jeden Raspberry Pi počítač. Aplikace je možné zmigrovat a překonfigurovat. Výkon je dostatečný.

```shell
uptime
 08:30:00 up 58 days, 20:14,  1 user,  load average: 0.16, 0.33, 0.46
```

## rpi03.navratil.lan

Raspberry Pi počítač s IPv4 adresou 192.168.4.52 s PostgreSQL RDBMS, do které jsou ukládány dosažené denní extrémy.

## fronius

Střídač fronius SYMO 5.0-3-S s IPv4 adresou 192.168.4.8 poskytující přes JSON API informace o stavu FVE.

## rpi19.navratil.lan s malým LCD displejem

Raspberry Pi počítač s IPv4 adresou 192.168.4.83, na kterém běží řídící aplikace v tmux multiplexoru a aktuální stav je zobrazován v oknech tmuxu a na LCD displeji.

## astaldo.navratil.cz

PC Engines router a firewall s OpenBSD, který realizuje připojení domácnosti do Internetu a chrání před Internetem vnitřní síť. Je dostupný na veřejné statické IPv4 109.164.115.11 a umožňuje připojení prostřednictvím ssh. Je dovolené přihlašování pouze s ssh klíčem nikoli heslem. Tento počítač je možné použít na přístup do vnitřní sítě z Internetu a na případné manuální zásahy na řídícím počítači.

## ohtar.navratil.lan

Lenovo ThinkPad notebook je primární stroj autora. Obsahuje privátní ed25519 ssh klíč autora a pomocí tohoto klíče a pouze tohoto klíče je možné se přihlašovat na jednotlivé počítače.

Dále obsahuje Git repozitář se zdrojovými kódy a Fossil SCM repozitář s diplomovou prací.
