# RaZberry Home

Tento projekt vznikl jako součást diplomové práce __Monitorování výroby a regulace spotřeby elektrické energie pomocí technologie Raspberry Pi__ pod vedením Ing. Josefa Pavlíčka, Ph.D. na ČZU v Praze. Tato dokumentace je z roku 2020 a popisuje verzi 1.0 ze dne 12.12.2020.

Řešení je nasazeno v domácnosti autora a nemělo by být dostupné pro nikoho jiného. Instrukce jsou součástí diplomové práce. __Jiří Navrátil__

## Spuštění 

Následující kroky předpokládají zprovozněný a již běžící systém. V rámci popisu jsou uvedny i některé kroky vedoucí ke spuštění dílčích úloh. Detailní návod je uveden na následujících stránkách.

### Připojte se do vnitřní sítě domácnosti

Pokud nejste ve vnitřní síti, tak se připojte na stroj `astaldo.navratil.cz`. Pokud se připojujete poprvé, tak ověřte klíče SSH serveru a jeho veřejnou statickou IPv4 adresu.

K připojení potřebujete privátní ed25519 ssh klíč autora. Přihlášení heslem není povoleno.

Otisky SSH klíčů z `astaldo.navratil.cz`

```shell
256 SHA256:XGfxmeEq/olzHFJQDAfG0Syl1LX4Eg7U+zXzejTwdB0 root@astaldo.navratil.cz (ED25519)
256 SHA256:ZJRzVWotgXGyeo+ziAk/M1uCoo0ic1qafYUlRSR1AXk root@astaldo.navratil.cz (ECDSA)
1024 SHA256:Go8IgR/CP6Yxw9iMpVFYKNAD9gjxJKFvk3folUwTV14 root@astaldo.navratil.cz (DSA)
2048 SHA256:0UHzzuJhwtidI5ysuP3JMVG9Q0wWdbDv8CplDSIDfYo root@astaldo.navratil.cz (RSA)
```


```shell
ssh -A astaldo.navratil.cz # 109.164.115.11
```

### Připojte se na počítač s řídícím programem

```shell
ssh 192.168.4.83 # rpi19.navratil.lan
```

### Použijte terminálový multiplexor tmux

Připojte se do běžícího tmuxu.

```shell
tmux attach
```

Pokud tmux neběží, tak se přepněte do adresáře `~/src/rh` a spusťte ho.

```shell
cd ~/src/rh
tmux
```

### Jednotlivé úlohy na řídícím počítači

Pokud tmux běžel, tak se zobrazí v okně `0 rh` výstup z běžící aplikace rh. Přepínání na další okna je možné pomocí `ctrl+b n` resp. v opačném směru pomocí `ctrl+b p`. Konkrétní okno, např. 0 je možné zvolit pomocí `ctrl+b 0`.

Pokud bylo nutné tmux spustit, tak bude potřeba také spustit i jednotlivé úlohy. V prvním okně číslo 0 v adresáři `~/src/rh`, který byl nastaven před spuštěním tmuxu proveďte tyto kroky.

```shell
. .venv/bin/activate
./rh.py | tee -a /tmp/rh.txt
```

Okno je možné pojmenovat pomocí

```shell
ctrl+b ,
rh
```

Otevřete další okno č. 1 a spusťte.

```shell
ctrl+b c
tail -f /tmp/rh.txt | sudo tee /dev/console
```

V obou oknech i na LCD panelu řídícího počítače jsou vidět stejné informace. Tady je příklad z 08.12.2020 od 11:03:46 do 11:04:22.

```shell
nabití   autonomie má sp. výroba spotřeba  síť      baterie součet obyvák kuchyň kluci holky koupelna chodba topení 08.12.2020
 13% vybíjení  55% 100%  2040W  -9061W   4064W nákup   3241W  285W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:46
 13% vybíjení  55% 100%  2030W  -9040W   4037W nákup   3246W  272W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:50
 13% vybíjení  55% 100%  2030W  -9029W   4038W nákup   3246W  285W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:52
 13% vybíjení  55% 100%  2025W  -9027W   4041W nákup   3249W  288W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:55
 13% vybíjení  55% 100%  2020W  -9036W   4030W nákup   3254W  267W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:57
 13% vybíjení  55% 100%  2020W  -9032W   4035W nákup   3257W  279W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:00
 13% vybíjení  55% 100%  2015W  -9009W   4015W nákup   3253W  274W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:02
 13% vybíjení  55% 100%  2020W  -9061W   4056W nákup   3262W  276W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:06
 13% vybíjení  56% 100%  2020W  -9039W   4022W nákup   3264W  267W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:08
 13% vybíjení  55% 100%  2020W  -9051W   4041W nákup   3260W  270W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:10
 13% vybíjení  55% 100%  2013W  -9020W   4035W nákup   3266W  295W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:14
 13% vybíjení  55% 100%  2004W  -9016W   4018W nákup   3265W  271W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:17
 13% vybíjení  55% 100%  2000W  -9042W   4041W nákup   3276W  274W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:20
 13% vybíjení  55% 100%  2000W  -9030W   4029W nákup   3276W  274W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:22
```
