# rpi19

Raspberry Pi 3 Model B Rev 1.2 počítač (BCM2835, revize a02082, 4x ARMv7 Processor rev 4 , 38.40 BogoMIPS) s Raspbian GNU/Linux 10 (buster) `rpi19.navratil.lan` s IPv4 adresou 192.168.4.84.

## Python

Běží na něm řídící program napsaný v **Python 3.7.3**. Je umístěn v adresáři `~/src/rh` a využívá tyto moduly nainstalované do virtuálního prostředí.

```shell
(rh) navratil@rpi19:~/src/rh $ cat requirements.txt 
influxdb
psycopg2-binary
pycodestyle
mkdocs
```

Resp. jsou v rámci závislostí nainstalované tyto moduly.

```shell
(rh) navratil@rpi19:~/src/rh $ pip freeze
certifi==2020.11.8
chardet==3.0.4
click==7.1.2
future==0.18.2
idna==2.10
importlib-metadata==3.1.1
influxdb==5.3.1
Jinja2==2.11.2
joblib==0.17.0
livereload==2.6.3
lunr==0.5.8
Markdown==3.3.3
MarkupSafe==1.1.1
mkdocs==1.1.2
msgpack==1.0.0
nltk==3.5
pkg-resources==0.0.0
psycopg2-binary==2.8.6
pycodestyle==2.6.0
python-dateutil==2.8.1
pytz==2020.4
PyYAML==5.3.1
regex==2020.11.13
requests==2.25.0
six==1.15.0
tornado==6.1
tqdm==4.54.1
urllib3==1.26.2
zipp==3.4.0
```

## Tmux 

Pro nepřetržitý provoz se využívá multiplexor tmux. 

Připojte se do běžícího tmuxu.

```shell
tmux attach
```

Pokud tmux neběží, tak se přepněte do adresáře `~/src/rh` a spusťte ho.

```shell
cd ~/src/rh
tmux
```

### Jednotlivé úlohy na řídícím počítači

Pokud tmux běžel, tak se zobrazí v okně `0 rh` výstup z běžící aplikace rh. Přepínání na další okna je možné pomocí `ctrl+b n` resp. v opačném směru pomocí `ctrl+b p`. Konkrétní okno, např. 0 je možné zvolit pomocí `ctrl+b 0`.

Pokud bylo nutné tmux spustit, tak bude potřeba také spustit i jednotlivé úlohy. V prvním okně číslo 0 v adresáři `~/src/rh`, který byl nastaven před spuštěním tmuxu proveďte tyto kroky.

```shell
. .venv/bin/activate
./rh.py | tee -a /tmp/rh.txt
```

První příkaz aktivuje virtuální prostředí a v něm nainstalované moduly. Druhý příkaz využije rouoru k tomu, aby výstup z aplikace rh.py posílal přes příkaz tee také do souboru /tmp/rh.txt. Pomocí parametru -a se zajistí nepřepsání, ale zapisování na konec.

Okno je možné pojmenovat pomocí

```shell
ctrl+b ,
rh
```

Otevřete další okno č. 1 a spusťte.

```shell
ctrl+b c
tail -f /tmp/rh.txt | sudo tee /dev/console
```

Soubor /tmp/rh.txt je posílán na console, což zajistí zobrazování na LCD displeji. Díky tomu rpi19 zobrazuje výstup aniž by musel být někdo přihlášený. Stačí fyzický přístup k displeji na kterém se průběžně zobrazuje stav.

V obou oknech i na LCD panelu řídícího počítače jsou vidět stejné informace. Tady je příklad z 08.12.2020 od 11:03:46 do 11:04:22.

```shell
nabití   autonomie má sp. výroba spotřeba  síť      baterie součet obyvák kuchyň kluci holky koupelna chodba topení 08.12.2020
 13% vybíjení  55% 100%  2040W  -9061W   4064W nákup   3241W  285W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:46
 13% vybíjení  55% 100%  2030W  -9040W   4037W nákup   3246W  272W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:50
 13% vybíjení  55% 100%  2030W  -9029W   4038W nákup   3246W  285W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:52
 13% vybíjení  55% 100%  2025W  -9027W   4041W nákup   3249W  288W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:55
 13% vybíjení  55% 100%  2020W  -9036W   4030W nákup   3254W  267W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:03:57
 13% vybíjení  55% 100%  2020W  -9032W   4035W nákup   3257W  279W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:00
 13% vybíjení  55% 100%  2015W  -9009W   4015W nákup   3253W  274W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:02
 13% vybíjení  55% 100%  2020W  -9061W   4056W nákup   3262W  276W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:06
 13% vybíjení  56% 100%  2020W  -9039W   4022W nákup   3264W  267W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:08
 13% vybíjení  55% 100%  2020W  -9051W   4041W nákup   3260W  270W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:10
 13% vybíjení  55% 100%  2013W  -9020W   4035W nákup   3266W  295W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:14
 13% vybíjení  55% 100%  2004W  -9016W   4018W nákup   3265W  271W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:17
 13% vybíjení  55% 100%  2000W  -9042W   4041W nákup   3276W  274W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:20
 13% vybíjení  55% 100%  2000W  -9030W   4029W nákup   3276W  274W 18.3°C 17.4°C 20.6°C 19.7°C 17.0°C 16.9°C ZAP      11:04:22
```
