#! /usr/bin/env python3

class Hub:
    u""" Třída pro práci s hubem """

    def __init__(self, ip, port, user, password, timeout):
        self._ip = ip
        self._port = port
        self._user = user
        self._password = password
        self._timeout = timeout
        self._url_info_level = "http://{}:{}/ZWaveAPI/Run/devices%5B{}%5D.instances%5B{}%5D.commandClasses%5B{}%5D.data.level.value".format(
            self._ip, self._port, "{}", "{}", "{}"
        )
        self._url_command_on = "http://{}:{}/ZAutomation/api/v1/devices/ZWayVDev_zway_{}-{}-{}/command/on".format(
            self._ip, self._port, "{}", "{}", "{}"
        )
        self._url_command_off = "http://{}:{}/ZAutomation/api/v1/devices/ZWayVDev_zway_{}-{}-{}/command/off".format(
            self._ip, self._port, "{}", "{}", "{}"
        )

    def print(self):
        print("Hub is at http://{}:{}/".format(self._ip, self._port))
        print(self.url_info_level)
        print(self.url_command_on)
        print(self.url_command_off)

    @property
    def host(self):
        return self._ip

    @property
    def port(self):
        return self._port

    @property
    def user(self):
        return self._user

    @property
    def password(self):
        return self._password

    @property
    def timeout(self):
        return self._timeout

    @property
    def url_info_level(self):
        return self._url_info_level

    @property
    def url_command_on(self):
        return self._url_command_on

    @property
    def url_command_off(self):
        return self._url_command_off
