#! /usr/bin/env python3
u""" Modul pro práci s pokoji """

import operator

class Room:
    u""" Třída pro práci s pokoji """
    # set of all rooms
    all_instances = set()

    @classmethod
    def get_set_of_instances(cls):
        return cls.all_instances

    @classmethod
    def get_list_of_instances_sorted_via_id(cls):
        return sorted(cls.all_instances, key=operator.attrgetter('_device_id'))

    @classmethod
    def get_list_of_instances_sorted_via_name(cls):
        return sorted(cls.all_instances, key=operator.attrgetter('_name'))

    @classmethod
    def print_all_rooms(cls):
        print("All rooms")
        for i in cls.get_list_of_instances_sorted_via_id():
            i.print()

    def __init__(self, hub, device_id, name):
        Room.all_instances.add(self)
        self._device_id = device_id
        self._name = name
        self._url = "http://%s:%d/smarthome/#/rooms/%d" % (
            # cls.hub_ip, cls.hub_port, device_id
            hub.host, hub.port, device_id
        )
        # set of all devices in this room
        self.devices_in_room = set()

    def add_device_to_room(self, device):
        self.devices_in_room.add(device)

    def get_set_of_devices_in_this_room(self):
        return self.devices_in_room

    def print(self):
        print("Devices in ", self._device_id, self._name, self._url)
        for i in self.get_set_of_devices_in_this_room():
            i.print()

